



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>MySQL性能分析脚本</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">MySQL性能分析脚本</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-04 15:02:37 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<div>
<pre class="prettyprint linenums">#!/usr/bin/python<br />
#!coding:utf-8

import mysql.connector as connector<br />
import json

"""<br />
目标       ：       这个工具用于分析MySQL实例的性能问题<br />
作者       ：       蒋乐兴<br />
QQ         ：       1721900707<br />
版本信息   ：       基于python3.4 MySQL 5.7.11<br />
MySQL用户要用到的一些权限：<br />
    create user admin@'127.0.0.1' identified by '131417';<br />
    grant select on performance_schema.* to admin@'localhost';<br />
"""

show_golbal_value="select variable_name,variable_value from performance_schema.global_variables where variable_name= %s"<br />
show_global_statu="select variable_name,variable_value from performance_schema.global_status where variable_name= %s"

def analyse_innodb_cache(cursor,results):<br />
    '''<br />
    用于分析innodb_buffer_pool的缓存命中率<br />
    '''<br />
    #查询出innodb_buffer_pool_read_requests<br />
    cursor.execute(show_global_statu,('Innodb_buffer_pool_read_requests',))<br />
    key,value=cursor.fetchone()<br />
    innodb_buffer_pool_read_requests=value<br />
    #查询出Innodb_buffer_pool_reads<br />
    cursor.execute(show_global_statu,('Innodb_buffer_pool_reads',))<br />
    key,value=cursor.fetchone()<br />
    Innodb_buffer_pool_reads=value<br />
    #计算结果<br />
    innodb_buffer_pool_hit_rate=float(innodb_buffer_pool_read_requests)/(float(innodb_buffer_pool_read_requests)+float(Innodb_buffer_pool_reads))<br />
    #组织结果<br />
    tempResult={}<br />
    tempResult['innodb_buffer_pool_read_requests']=innodb_buffer_pool_read_requests<br />
    tempResult['Innodb_buffer_pool_reads']=Innodb_buffer_pool_reads<br />
    tempResult['innodb_buffer_pool_hit_rate']=innodb_buffer_pool_hit_rate

    results['innodb_buffer_pool_hit_rate']=tempResult

def analyse_query_no_use_index(curosr,results):<br />
    """<br />
    用于分析没有用索引的查询,最多只返回8条没有使用索引的SQL;执行次数越多的SQL在结果集中越靠前。<br />
    """<br />
    query="select digest_text,sum_no_index_used from performance_schema.events_statements_summary_by_digest where sum_no_index_used&gt;=1 and digest_text not like 'SHOW%' order by  sum_no_index_used desc limit 8"<br />
    cursor.execute(query)<br />
    index=0<br />
    tempResult={}<br />
    for digest_text,sum_no_use_index in curosr:<br />
        tempResult[index]=digest_text<br />
        index=index+1<br />
    results['analyse_query_no_use_index']=tempResult

def analyse_query_cache(cursor,results):<br />
    """<br />
    本函数用于分析mysql实例的查询缓存、如果query_cache_type=0说明没有开启这个工能，那么分析结束。<br />
    不然要分析查询缓存的剩余内存，和命中率。把分析的结果包装到results变量中。<br />
    """<br />
    analysis_var=("query_cache_type",)<br />
    cursor.execute(show_golbal_value,analysis_var)<br />
    key,value=cursor.fetchone()<br />
    #如果value的值等于OFF、说明本实例并没有开启查询缓存。<br />
    if value=='OFF':<br />
        results['query_cache']='query cache function not in use for this instance'<br />
    else:<br />
        #如果逻辑走到了这里说明、实例开启了查询缓存<br />
        #Qcache_free_memory 对应着剩余的查询缓存内存。<br />
        cursor.execute(show_global_statu,("Qcache_free_memory",))<br />
        key,value = cursor.fetchone()<br />
        #由于这个是延时计算的；所以查出来就要把它用掉。********************<br />
        Qcache_free_memory=value<br />
        #query_cache_size   对应着查询缓存的内存大小。<br />
        cursor.execute(show_golbal_value,("query_cache_size",))<br />
        key,value = cursor.fetchone();<br />
        query_cache_size=value<br />
        #用于查询缓存的内存空闲率<br />
        if float(query_cache_size) != 0:<br />
            query_cache_memory_free_rate=float(Qcache_free_memory)/float(query_cache_size)<br />
        else:<br />
            query_cache_memory_free_rate=None<br />
        #Qcache_hits    对应着命中的次数<br />
        cursor.execute(show_global_statu,("Qcache_hits",))<br />
        key,value=cursor.fetchone()<br />
        Qcache_hits=value<br />
        #Qcache_inserts 对应的没有命中的次数----由于没有命中所以要插入。<br />
        cursor.execute(show_global_statu,("Qcache_inserts",))<br />
        key,value=cursor.fetchone()<br />
        Qcache_inserts=value<br />
        #查询缓存的命中率为<br />
        if float(Qcache_hits+Qcache_inserts) != 0:<br />
            query_cache_hit_rate=float(Qcache_hits)/float(Qcache_hits+Qcache_inserts)<br />
        else:<br />
            query_cache_hit_rate=None<br />
        #组织结果<br />
        tempResult={}<br />
        tempResult['Qcache_free_memory']=Qcache_free_memory<br />
        tempResult['query_cache_size']=query_cache_size<br />
        tempResult['query_cache_memory_free_rate']=query_cache_memory_free_rate<br />
        tempResult['Qcache_hits']=Qcache_hits<br />
        tempResult['Qcache_inserts']=Qcache_inserts<br />
        tempResult['query_cache_hit_rate']=query_cache_hit_rate<br />
        results['query_cache']=tempResult

analysis_function_sets={<br />
    'anaylsis_query_cache':analyse_query_cache,<br />
    'analyse_query_no_use_index':analyse_query_no_use_index,<br />
    'analyse_innodb_cache':analyse_innodb_cache<br />
    }

if __name__=="__main__":<br />
    cnx=None<br />
    cursor=None<br />
    config={<br />
        'host':'127.0.0.1',<br />
        'port':3306,<br />
        'user':'admin',<br />
        'password':''<br />
        }<br />
    results={}<br />
    try:<br />
        cnx=connector.connect(**config)<br />
        cursor=cnx.cursor(buffered=True)<br />
        for key,function in analysis_function_sets.items():<br />
            print('start analyse {0}'.format(key))<br />
            function(cursor,results)<br />
        print(json.dumps(results))<br />
    except Exception as err:<br />
        print(err)<br />
    finally:<br />
        if cnx != None:<br />
            cnx.close()<br />
            cursor.close()</pre>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/3902v4oq.html">Javascript中addEventListener和attachEvent的区别</a>
		</li>
						<li><a href="https://www.batexi.com/a/39r0wym9.html">MVC中获取来自控制器名称与动作的方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/m96dd238.html">discuz中方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/1q2vedo8.html">Java反射API使用实例</a>
		</li>
						<li><a href="https://www.batexi.com/a/wq121p29.html">MySQL学习笔记&mdash;&mdash;存储过程</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvv5d7zq.html">转：Order&amp;amp&semi;Shipping Transactions Status Summary</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwdo4wl8.html">CF A&period; Xenia and Divisors</a>
		</li>
						<li><a href="https://www.batexi.com/a/8z1jxo19.html">【转】Ajax 基础学习</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4yvgz5q.html">手工构建ISO的基本步骤</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdem3vv9.html">Linux学习笔记1：配置Linux网络和克隆虚拟机并更改配置</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rdjee78.html">SubLime2 乱码解决</a>
		</li>
						<li><a href="https://www.batexi.com/a/8eyw00k9.html">c&num; 中事务处理</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kpgnx59.html">D-BUS详细分析</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4ze4z59.html">&amp;lt&semi;iframe&amp;gt&semi;和&amp;lt&semi;frame&amp;gt&semi;区别</a>
		</li>
						<li><a href="https://www.batexi.com/a/9600v4y9.html">&lbrack;转&rsqb;Angular4首页加载慢优化之路</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyyggddq.html">&lbrack;redis&rsqb; hiredis-vip 简单使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7oj57e8.html">cmd 命令</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7op2zk8.html">springboot自定义静态文件目录&comma;解决jar打包后修改页面等静态文件的问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rnyzp4q.html">vertx读取配置文件&comma;获得端口号</a>
		</li>
						<li><a href="https://www.batexi.com/a/8koddmjq.html">数学建模 数据包络分析&lpar;DEA&rpar; Lingo实现</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/q2w4jgwq.html">POSTGRESQL小玩</a>
			</li>
						<li><a href="https://www.batexi.com/a/9rdxglr8.html">LED驅動芯片對LED壽命的影響</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwd2j1y8.html">MFC新婚之夜（笑昏，大概是指MFC的人固步自封）</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1z3rez9.html">B450配置</a>
			</li>
						<li><a href="https://www.batexi.com/a/8oke4kx9.html">COJ 0358 xjr考考你数据结构（根号3）线段树区间修改</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1z350z9.html">Ubuntu 14&period;04 64位安装Android Studio 和 genymotion （上）</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1z3p549.html">Linux开关机命令详解</a>
			</li>
						<li><a href="https://www.batexi.com/a/8oke5g19.html">执行npm安装模块的命令  Cannot find module</a>
			</li>
						<li><a href="https://www.batexi.com/a/qde2om09.html">JavaScript  单例模式实现</a>
			</li>
						<li><a href="https://www.batexi.com/a/qvvlry1q.html">类型兼容原则（C&plus;&plus;）</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
